<?php
add_action('admin_menu', 'easy_pinning_menu'); //initialization hook
/* ADD OPTIONS PAGE & REGISTER OPTIONS */

function easy_pinning_menu() {
    add_options_page('Pin Button Attraction Options', 'Pin Button Attraction', 'manage_options', 'pin-button-attraction', 'easy_pinning_options');
    add_action('admin_init', 'register_easy_pinning_settings');
}

/* REGISTER OPTIONS HOOK */

function register_easy_pinning_settings() {
    register_setting('ep-settings-group', 'ep_global_switch');
    register_setting('ep-settings-group', 'ep_display_username');
    register_setting('ep-settings-group', 'ep_username');
    register_setting('ep-settings-group', 'ep_jquery_option');
    register_setting('ep-settings-group', 'ep_performance');
    register_setting('ep-settings-group', 'ep_global_position');
    register_setting('ep-settings-group', 'ep_display_mouseover');
    register_setting('ep-settings-group', 'ep_global_layout');
    register_setting('ep-settings-group', 'ep_image_switch_option');
    register_setting('ep-settings-group', 'ep_page_switch_option');
    register_setting('ep-settings-group', 'ep_homepage_pin_option');
    register_setting('ep-settings-group', 'ep_featured_pin_option');
}

/* CHECK SETTING STATUS */

function ep_functional() {
    $switch = get_option('ep_global_switch', 'not_set');
    return ($switch == 'not_set' || $switch == 1) ? true : false;
}

/* DISPLAY USERNAME OR NOT */

function ep_display_username() {
    $display = get_option('ep_display_username', 'not_set');
    return ($display == 'not_set' || $display == 1) ? true : false;
}

/* RETURN PINTEREST USERNAME */

function ep_username() {
    $username = get_option('ep_username');
    return $username;
}

/* CHECK JQUERY STATUS */

function ep_jquery() {
    $jquery = get_option('ep_jquery_option', 1);
    return ($jquery == 1) ? true : false;
}

/* CHECK PERFORMANCE */

function ep_performance() {
    $performance = get_option('ep_performance', 1);
    return $performance;
}

/* CHECK POSITION */

function ep_pin_position() {
    $position = get_option('ep_global_position', 'pin-wrapper-top-left');
    return $position;
}

/* CHECK MOUSEOVER EFFECT */

function ep_display_mouseover() {
    $mouseover = get_option('ep_display_mouseover', 'show-always');
    return $mouseover;
}

/* CHECK IMAGE PIN DEFAULT VALUE */

function ep_image_switch() {
    $image_switch = get_option('ep_image_switch_option', 1);
    return ($image_switch == 1) ? true : false;
}

/* CHECK PAGE / POST PIN DEFAULT VALUE */

function ep_page_switch() {
    $page_switch = get_option('ep_page_switch_option', 1);
    return ($page_switch == 1) ? true : false;
}

/* CHECK HOMEPAGE PIN STATUS */

function ep_homepage_pin() {
    $homepage_pin = get_option('ep_homepage_pin_option', 1);
    return ($homepage_pin == 1) ? true : false;
}

/* CHECK FEATURED IMAGE PIN STATUS */

function ep_featured_pin() {
    $featured_pin = get_option('ep_featured_pin_option', 1);
    return ($featured_pin == 1) ? true : false;
}

/* CHECK BUTTON COUNT */

function ep_pin_layout() {
    $layout = get_option('ep_global_layout', 'horizontal');
    return $layout;
}

/* AJAX CALL TO DISABLE ALL PAGE PINS */
add_action('wp_ajax_ep_disable_page_pins', 'ep_disable_page_pins');

function ep_disable_page_pins() {
    ep_update_page_display(2);
    _e('<span class="ep-pins-disabled">Pinterest Button has been <strong>disabled</strong> for all posts &amp; pages</span>');
    exit;
}

/* AJAX CALL TO ENABLE ALL PAGE PINS */
add_action('wp_ajax_ep_enable_page_pins', 'ep_enable_page_pins');

function ep_enable_page_pins() {
    ep_update_page_display(1);
    _e('<span class="ep-pins-enabled">Pinterest Button has been <strong>enabled</strong> for all posts &amp; pages</span>');
    exit;
}

/* UPDATE pinterest_display CUSTOM FIELD ON ALL POST & PAGES */

function ep_update_page_display($value = '') {
    if (empty($value))
        $value = 1;

    $post_types = array('post', 'page');
    foreach ($post_types as $type):
        $args = array(
            'post_type' => $type,
            'posts_per_page' => -1
        );
        $query = new WP_Query($args);
        if ($query->have_posts()): while ($query->have_posts()):$query->the_post();
                update_post_meta($query->post->ID, 'pinterest_display', $value);
            endwhile;
        endif;
        wp_reset_postdata();
    endforeach;
}

/* DISPLAY OPTIONS */

function easy_pinning_options() {
    global $title;
    ?>
    <div class="wrap">
        <div class="icon32 icon32-posts-post" id="icon-edit"><br></div>
        <h2><?php echo $title ?></h2>
        <form method="post" action="options.php">
            <?php settings_fields('ep-settings-group'); ?>
            <?php settings_errors(); ?>
            <?php do_settings_fields('ep-settings-group', ''); ?>
            <h3><?php _e('General Settings'); ?></h3>
            <table class="form-table easy-pinning-table">

                <tr valign="top">
                    <?php $bool = ep_functional(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Enable Plugin:'); ?></th>
                    <td class="cell-wrapper">
                        <p class="position-wrapper">
                            <label for="ep_global_switch1"><?php _e('Yes'); ?></label><input type="radio" id="ep_global_switch1" name="ep_global_switch" value="1" <?php echo ($bool) ? 'checked="checked"' : ''; ?> />
                        </p>
                        <p class="position-wrapper">
                            <label for="ep_global_switch2"><?php _e('No'); ?></label><input type="radio" id="ep_global_switch2" name="ep_global_switch" value="2" <?php echo (!$bool) ? 'checked="checked"' : ''; ?> />
                        </p>
                        <span class="description"><?php _e('Careful! Setting this to No will disable ALL the pin buttons across your site.  However, your Pin button settings will be saved.'); ?></span>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row" class="cell-wrapper"><?php _e('Add "Follow me on Pinterest" Button to each image:'); ?></th>
                    <td class="cell-wrapper">
                        <?php
                        $display_username = ep_display_username();
                        $username = ep_username();
                        ?>
                        <label for="ep_display_username" class="ep-valign"><?php _e('Show Username'); ?></label><input type="checkbox" id="ep_display_username" name="ep_display_username" value="1"  class="ep-valign" <?php echo ($display_username) ? 'checked="checked"' : ''; ?> /><input type="text" name="ep_username" value="<?php echo $username ?>" size="45" />
                        <span class="description ep-block"><?php _e('Insert Pinterest Username. If checkbox is ticked the "Follow me on Pinterest" button will also be displayed.'); ?></span>
                    </td>
                </tr>

                <tr valign="top">
                    <?php $jquery = ep_jquery(); ?>
                    <th scope="row"><?php _e('Turn jQuery On / Off:'); ?></th>
                    <td>
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'On', 'default' => true),
                            array('value' => 2, 'text' => 'Off', 'default' => false)
                        );
                        ?>
                        <select name="ep_jquery_option" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['default'] == $jquery) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('Turn this OFF if the plugin is not working as intended'); ?></span>
                    </td>
                </tr>
                <tr valign="top">
                    <?php $performance = ep_performance(); ?>
                    <th scope="row"><?php _e('Load Pinterest Timing'); ?></th>
                    <td>
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'During Page Load'),
                            array('value' => 2, 'text' => 'After Page Load')
                        );
                        ?>
                        <select name="ep_performance" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['value'] == $performance) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('Select first option for best performance. However, in some cases, the second one is better for more accurate results, but slower load time.'); ?></span>
                    </td>
                </tr>
            </table>
            <h3><?php _e('Styling'); ?></h3>
            <table class="form-table easy-pinning-table">
                <tr valign="top">
                    <?php $position = ep_pin_position(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Pinterest Button Position'); ?></th>
                    <td class="cell-wrapper">
                        <?php
                        $options = array(
                            'pin-wrapper-top-right' => 'Top Right',
                            'pin-wrapper-top-left' => 'Top Left',
                            'pin-wrapper-bottom-right' => 'Bottom Right',
                            'pin-wrapper-bottom-left' => 'Bottom Left'
                        );
                        ?>
                        <select name="ep_global_position" class="ep-select-wrapper">
                            <?php foreach ($options as $value => $text): ?>
                                <option value="<?php echo $value ?>"<?php if ($value == $position) echo ' selected="selected"'; ?>><?php _e($text); ?></option>
                            <?php endforeach; ?>
                        </select>
                    </td>
                </tr>
                <tr valign="top">
                    <?php $layout = ep_pin_layout(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Pinterest Button Display'); ?></th>
                    <td class="cell-wrapper">
                        <p><label for="pin-layout-vertical"><?php _e('Vertical Count'); ?></label> <input type="radio" name="ep_global_layout" id="pin-layout-vertical" value="vertical" <?php echo ($layout == 'vertical') ? 'checked="checked"' : ''; ?> /> <img src="<?php echo E_URL ?>/assets/img/pin_ver.png" alt="" /></p>
                        <p><label for="pin-layout-horizontal"><?php _e('Horizontal Count'); ?></label> <input type="radio" name="ep_global_layout" id="pin-layout-horizontal" value="horizontal" <?php echo ($layout == 'horizontal') ? 'checked="checked"' : ''; ?> /> <img src="<?php echo E_URL ?>/assets/img/pin_hor.png" alt="" /></p>
                        <p><label for="pin-layout-none"><?php _e('No Count'); ?></label> <input type="radio" name="ep_global_layout" id="pin-layout-none" value="none" <?php echo ($layout == 'none') ? 'checked="checked"' : ''; ?> /> <img src="<?php echo E_URL ?>/assets/img/pin_none.png" alt="" /></p>

                    </td>
                </tr>
                <tr valign="top">
                    <?php $mouseover = ep_display_mouseover(); ?>
                    <th scope="row"><?php _e('Pin Button Effect'); ?></th>
                    <td>
                        <?php
                        $options = array(
                            'show-always' => 'Show Always',
                            'show-mouseover' => 'Show on Mouseover'
                        );
                        ?>
                        <select name="ep_display_mouseover" class="ep-select-wrapper ep-select-span">
                            <?php foreach ($options as $value => $text): ?>
                                <option value="<?php echo $value ?>"<?php if ($value == $mouseover) echo ' selected="selected"'; ?>><?php _e($text); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block">Choose whether to always show the Pin button or only on mouseover.</span>
                    </td>
                </tr>
            </table>
            <h3><?php _e('Default Settings for New Images, Posts, and Pages'); ?></h3>
            <table class="form-table easy-pinning-table">
                <tr valign="top">
                    <?php $image_switch = ep_image_switch(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Default Image Pin Status:'); ?></th>
                    <td class="cell-wrapper">
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'On', 'default' => true),
                            array('value' => 2, 'text' => 'Off', 'default' => false)
                        );
                        ?>
                        <select name="ep_image_switch_option" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['default'] == $image_switch) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('When inserting an image, should the default setting be for the Pinterest button to be on for the image, or off?'); ?></span>
                    </td>
                </tr>
                <tr valign="top">
                    <?php $page_switch = ep_page_switch(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Default Page / Post Pin Status:'); ?></th>
                    <td class="cell-wrapper">
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'On', 'default' => true),
                            array('value' => 2, 'text' => 'Off', 'default' => false)
                        );
                        ?>
                        <select name="ep_page_switch_option" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['default'] == $page_switch) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('When a new post or page is created, should the default setting be for the Pinterest buttons be on for the post/page, or off?'); ?></span>
                    </td>
                </tr>
                <tr valign="top">
                    <?php $homepage_pin = ep_homepage_pin(); ?>
                    <th scope="row" class="cell-wrapper"><?php _e('Pin Images on Homepage:'); ?></th>
                    <td class="cell-wrapper">
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'On', 'default' => true),
                            array('value' => 2, 'text' => 'Off', 'default' => false)
                        );
                        ?>
                        <select name="ep_homepage_pin_option" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['default'] == $homepage_pin) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('Display Pin Button on Homepage?'); ?></span>
                    </td>
                </tr>
                <tr valign="top">
                    <?php $featured_pin = ep_featured_pin(); ?>
                    <th scope="row"><?php _e('Pin Featured Images:'); ?></th>
                    <td>
                        <?php
                        $options = array(
                            array('value' => 1, 'text' => 'On', 'default' => true),
                            array('value' => 2, 'text' => 'Off', 'default' => false)
                        );
                        ?>
                        <select name="ep_featured_pin_option" class="ep-select-wrapper">
                            <?php foreach ($options as $option): ?>
                                <option value="<?php echo $option['value'] ?>"<?php if ($option['default'] == $featured_pin) echo ' selected="selected"'; ?>><?php _e($option['text']); ?></option>
                            <?php endforeach; ?>
                        </select>
                        <span class="description ep-block"><?php _e('Display Pin Button on featured images throughout the site? <strong>CAREFUL!</strong> By default, all individual featured image pins are off, so you need to turn them on manually.'); ?></span>
                    </td>
                </tr>
            </table>
            <h3><?php _e('Bulk Update'); ?></h3>
            <table class="form-table easy-pinning-table">
                <tr valign="top">
                    <th scope="row"><?php _e('Bulk Post &amp; Page Update'); ?></th>
                    <td>
                        <input type="button" class="button-secondary ep-switch-page-off" value="<?php _e('Turn Pinterest OFF'); ?>" />
                        <input type="button" class="button-secondary ep-switch-page-on" value="<?php _e('Turn Pinterest ON'); ?>" />
                        <span class="description ep-block"><?php _e('Clicking one of these buttons will turn the Pinterest button on or off for all existing Posts & Pages.  Careful - this will override any individual settings you have on images, and those individual settings cannot be recovered after taking this action'); ?></span>
                        <span class="description" id="reset-message-wrapper"></span>
                    </td>
                </tr>
            </table>

            <p class="submit">
                <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
            </p>

        </form>

    </div>
    <?php
}
?>